//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be perfomring new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
        return 1;
}
//---------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>

void flog(char *s)
{
 FILE *fo = fopen ("c:\\temp\\trace.log","at");
 fprintf (fo,"%s\n",s);
 fclose (fo);
}


 int strNoCaseCmp (char *a, char *b, int len)
{
 while (len--)
 {
  if (*a!=*b) return 0;
  a++; b++;
 }
 return 1;
}


int substr (char *a, char *b, int sublen)
{
 int len = strlen (b);
 for (int i=0; i<=(len-sublen); i++)
     {
      if (strNoCaseCmp (a,b+i,sublen)) return 1;
     }
 return 0;
}




double basecmp (char *a, char *b)
{
 double target = 0.;
 int fullen = strlen (a);
 int tlen = strlen (b);
 if (fullen>tlen) fullen = tlen;
 for (int qletter=1; qletter <= fullen; qletter++)
     {
      for (int letter=0; letter <= (fullen-qletter); letter++)
          {
           if (substr(a+letter,b,qletter))
              {
               double t = (1./(fullen-qletter+1.));
               target +=t;
              }
          }
     }

 return (target/fullen);
}


extern "C" double __stdcall __export stringcmp (char *a, char * b)
{
  return basecmp (a,b);
// return 0.5;
}

